
-- Inicialización----------------------------------------
---------------------------------------------------------

BiSList = LibStub("AceAddon-3.0"):NewAddon("BiSList", "AceConsole-3.0", "AceHook-3.0", "AceComm-3.0", "AceSerializer-3.0")
local L = LibStub("AceLocale-3.0"):GetLocale("BiSList", true)

local gui = LibStub("AceGUI-3.0")
BiSList:RegisterChatCommand("bislist", "OpenBiSList")
BiSList:RegisterChatCommand("bistest", "OpenTestWindow")


options = 
{
	type = "group",
	args = 
	{
		armadura =
		{
			type="group",
			name= L["armor"],
			desc="",
			args=
			{
    			addHeadTitle = 
				{
    				type = "header",
    				name = "Cabeza",
    				order = 1
				},
				addHeadslot =
				{
					type = "input",
					name = "Cabeza",
					desc = "Escribe el item de cabeza",
					set = function(info, input) 	BiSList.db.profile.headSlot = BiSList:GetItemIDByName(input) end,
					get = function(info) return BiSList:GetItemNameByID(BiSList.db.profile.headSlot) end,
					order = 2
				},
				addHeadNote =
				{
					type = "input",
					name = "Nota",
					desc = "Escribe el item de cabeza",
					set = function(info, input) 	BiSList.db.profile.headNote =input end,
					get = function(info) return BiSList.db.profile.headNote end,
					order = 3
				},
				addShoulderTitle = 
				{
    				type = "header",
    				name = "Hombros",
    				order = 4
				},
				addShoulderSlot =
				{
					type = "input",
					name = "Hombros",
					desc = "Escribe el item de hombros",
					set = function(info, input) 	BiSList.db.profile.shoulderSlot = BiSList:GetItemIDByName(input) end,
					get = function(info) return BiSList:GetItemNameByID(BiSList.db.profile.shoulderSlot) end,
					order = 5
				},
				addShoulderNote =
				{
					type = "input",
					name = "Nota",
					desc = "Escribe el item de cabeza",
					set = function(info, input) 	BiSList.db.profile.shoulderNote =input end,
					get = function(info) return BiSList.db.profile.shoulderNote end,
					order = 6
				},
				addBackTitle = 
				{
    				type = "header",
    				name = "Capa",
    				order = 7
				},
				addBackSlot =
				{
					type = "input",
					name = "Espalda",
					desc = "Escribe el item de espalda",
					set = function(info, input) 	BiSList.db.profile.backSlot = BiSList:GetItemIDByName(input) end,
					get = function(info) return BiSList:GetItemNameByID(BiSList.db.profile.backSlot) end,
					order = 8
				},
				addBackNote =
				{
					type = "input",
					name = "Nota",
					desc = "Escribe el item de cabeza",
					set = function(info, input) 	BiSList.db.profile.backNote =input end,
					get = function(info) return BiSList.db.profile.backNote end,
					order = 9
				},
				addChestTitle = 
				{
    				type = "header",
    				name = "Pecho",
    				order = 10
				},
				addChestSlot =
				{
					type = "input",
					name = "Pecho",
					desc = "Escribe el item de pecho",
					set = function(info, input) 	BiSList.db.profile.chestSlot = BiSList:GetItemIDByName(input) end,
					get = function(info) return BiSList:GetItemNameByID(BiSList.db.profile.chestSlot) end,
					order = 11
				},
				addChestNote =
				{
					type = "input",
					name = "Nota",
					desc = "Escribe el item de cabeza",
					set = function(info, input) 	BiSList.db.profile.chestNote =input end,
					get = function(info) return BiSList.db.profile.chestNote end,
					order = 12
				},
				addWristTitle = 
				{
    				type = "header",
    				name = "Muñeca",
    				order = 13
				},
				addWristSlot =
				{
					type = "input",
					name = "Muñeca",
					desc = "Escribe el item de muñeca",
					set = function(info, input) 	BiSList.db.profile.wristSlot = BiSList:GetItemIDByName(input) end,
					get = function(info) return BiSList:GetItemNameByID(BiSList.db.profile.wristSlot) end,
					order = 14
				},
				addWristNote =
				{
					type = "input",
					name = "Nota",
					desc = "Escribe el item de cabeza",
					set = function(info, input) 	BiSList.db.profile.wristNote =input end,
					get = function(info) return BiSList.db.profile.wristNote end,
					order = 15
				},
				addHandTitle = 
				{
    				type = "header",
    				name = "Manos",
    				order = 16
				},
				addHandSlot =
				{
					type = "input",
					name = "Manos",
					desc = "Escribe el item de manos",
					set = function(info, input) 	BiSList.db.profile.handsSlot = BiSList:GetItemIDByName(input) end,
					get = function(info) return BiSList:GetItemNameByID(BiSList.db.profile.handsSlot) end,
					order = 17
				},
				addHandNote =
				{
					type = "input",
					name = "Nota",
					desc = "Escribe el item de cabeza",
					set = function(info, input) 	BiSList.db.profile.handsNote =input end,
					get = function(info) return BiSList.db.profile.handsNote end,
					order = 18
				},
				addWaistTitle = 
				{
    				type = "header",
    				name = "Cintura",
    				order = 19
				},
				addWaistSlot =
				{
					type = "input",
					name = "Cintura",
					desc = "Escribe el item de cintura",
					set = function(info, input) 	BiSList.db.profile.waistSlot = BiSList:GetItemIDByName(input) end,
					get = function(info) return BiSList:GetItemNameByID(BiSList.db.profile.waistSlot) end,
					order = 20
				},
				addWaistNote =
				{
					type = "input",
					name = "Nota",
					desc = "Escribe el item de cabeza",
					set = function(info, input) 	BiSList.db.profile.waistNote =input end,
					get = function(info) return BiSList.db.profile.waistNote end,
					order = 21
				},
				addLegsTitle = 
				{
    				type = "header",
    				name = "Piernas",
    				order = 22
				},
				addLegSlot =
				{
					type = "input",
					name = "Piernas",
					desc = "Escribe el item de piernas",
					set = function(info, input) 	BiSList.db.profile.legsSlot = BiSList:GetItemIDByName(input) end,
					get = function(info) return BiSList:GetItemNameByID(BiSList.db.profile.legsSlot) end,
					order = 23
				},
				addLegNote =
				{
					type = "input",
					name = "Nota",
					desc = "Escribe el item de cabeza",
					set = function(info, input) 	BiSList.db.profile.legsNote =input end,
					get = function(info) return BiSList.db.profile.legsNote end,
					order = 24
				},
				addFeetTitle = 
				{
    				type = "header",
    				name = "Pies",
    				order = 25
				},
				addFeetSlot =
				{
					type = "input",
					name = "Pies",
					desc = "Escribe el item de pies",
					set = function(info, input) 	BiSList.db.profile.feetSlot = BiSList:GetItemIDByName(input) end,
					get = function(info) return BiSList:GetItemNameByID(BiSList.db.profile.feetSlot) end,
					order = 26
				},
				addFeetNote =
				{
					type = "input",
					name = "Nota",
					desc = "Escribe el item de cabeza",
					set = function(info, input) 	BiSList.db.profile.feetNote =input end,
					get = function(info) return BiSList.db.profile.feetNote end,
					order = 27
				},
			},
		},
		armas =
		{
			type="group",
			name="Armas",
			desc="",
			args=
			{
				addMainHandTitle = 
				{
    				type = "header",
    				name = "Mano derecha",
    				order = 28
				},
				addMainHandSlot =
				{
					type = "input",
					name = "Mano Derecha",
					desc = "Escribe el item de mano derecha",
					set = function(info, input) 	BiSList.db.profile.mainHandSlot = BiSList:GetItemIDByName(input) end,
					get = function(info) return BiSList:GetItemNameByID(BiSList.db.profile.mainHandSlot) end,
					order = 29
				},
				addMainHandNote =
				{
					type = "input",
					name = "Nota",
					desc = "Escribe el item de cabeza",
					set = function(info, input) 	BiSList.db.profile.mainHandNote =input end,
					get = function(info) return BiSList.db.profile.mainHandNote end,
					order = 30
				},
				addOffHandTitle = 
				{
    				type = "header",
    				name = "Mano izquierda",
    				order = 31
				},
				addOffHandSlot =
				{
					type = "input",
					name = "Mano Izquierda",
					desc = "Escribe el item de mano izquierda",
					set = function(info, input) 	BiSList.db.profile.offHandSlot = BiSList:GetItemIDByName(input) end,
					get = function(info) return BiSList:GetItemNameByID(BiSList.db.profile.offHandSlot) end,
					order = 32
				},
				addOffHandNote =
				{
					type = "input",
					name = "Nota",
					desc = "Escribe el item de cabeza",
					set = function(info, input) 	BiSList.db.profile.offHandNote =input end,
					get = function(info) return BiSList.db.profile.offHandNote end,
					order = 33
				},
				addRangedTitle = 
				{
    				type = "header",
    				name = "Distancia",
    				order = 34
				},
				addDistanceSlot =
				{
					type = "input",
					name = "Distancia",
					desc = "Escribe el item de mano a distancia",
					set = function(info, input) 	BiSList.db.profile.distanceSlot = BiSList:GetItemIDByName(input) end,
					get = function(info) return BiSList:GetItemNameByID(BiSList.db.profile.distanceSlot) end,
					order = 35
				},
				addDistanceNote =
				{
					type = "input",
					name = "Nota",
					desc = "Escribe el item de cabeza",
					set = function(info, input) 	BiSList.db.profile.distanceNote =input end,
					get = function(info) return BiSList.db.profile.distanceNote end,
					order = 36
				},
			},
		},
		joyas =
		{
			type="group",
			name="Joyas",
			desc="",
			args=
			{
				addNeckTitle = 
				{
    				type = "header",
    				name = "Collar",
    				order = 37
				},
				addNeckSlot =
				{
					type = "input",
					name = "Collar",
					desc = "Escribe el item de mano a distancia",
					set = function(info, input) 	BiSList.db.profile.neckSlot = BiSList:GetItemIDByName(input) end,
					get = function(info) return BiSList:GetItemNameByID(BiSList.db.profile.neckSlot) end,
					order = 38
				},
				addNeckNote =
				{
					type = "input",
					name = "Nota",
					desc = "Escribe el item de cabeza",
					set = function(info, input) 	BiSList.db.profile.neckNote =input end,
					get = function(info) return BiSList.db.profile.neckNote end,
					order = 39
				},
				addRing1Title = 
				{
    				type = "header",
    				name = "Anillo 1",
    				order = 40
				},
				addRing1Slot =
				{
					type = "input",
					name = "Anillo 1",
					desc = "Escribe el item de mano a distancia",
					set = function(info, input) 	BiSList.db.profile.ring1Slot = BiSList:GetItemIDByName(input) end,
					get = function(info) return BiSList:GetItemNameByID(BiSList.db.profile.ring1Slot) end,
					order = 41
				},
				addRing1Note =
				{
					type = "input",
					name = "Nota",
					desc = "Escribe el item de cabeza",
					set = function(info, input) 	BiSList.db.profile.ring1Note =input end,
					get = function(info) return BiSList.db.profile.ring1Note end,
					order = 42
				},
				addRing2Title = 
				{
    				type = "header",
    				name = "Anillo 2",
    				order = 43
				},
				addRing2Slot =
				{
					type = "input",
					name = "Anillo 2",
					desc = "Escribe el item de mano a distancia",
					set = function(info, input) 	BiSList.db.profile.ring2Slot = BiSList:GetItemIDByName(input) end,
					get = function(info) return BiSList:GetItemNameByID(BiSList.db.profile.ring2Slot) end,
					order = 44
				},
				addRing2Note =
				{
					type = "input",
					name = "Nota",
					desc = "Escribe el item de cabeza",
					set = function(info, input) 	BiSList.db.profile.ring2Note =input end,
					get = function(info) return BiSList.db.profile.ring2Note end,
					order = 45
				},
				addTrinket1Title = 
				{
    				type = "header",
    				name = "Abalorio 1",
    				order = 46
				},
				addTrinket1Slot =
				{
					type = "input",
					name = "Abalorio 1",
					desc = "Escribe el item de mano a distancia",
					set = function(info, input) 	BiSList.db.profile.trinket1Slot = BiSList:GetItemIDByName(input) end,
					get = function(info) return BiSList:GetItemNameByID(BiSList.db.profile.trinket1Slot) end,
					order = 47
				},
				addTrinket1Note =
				{
					type = "input",
					name = "Nota",
					desc = "Escribe el item de cabeza",
					set = function(info, input) 	BiSList.db.profile.trinket1Note =input end,
					get = function(info) return BiSList.db.profile.trinket1Note end,
					order = 48
				},
				addTrinket2Title = 
				{
    				type = "header",
    				name = "Abalorio 2",
    				order = 49
				},
				addTrinket2Slot =
				{
					type = "input",
					name = "Abalorio 2",
					desc = "Escribe el item de mano a distancia",
					set = function(info, input) 	BiSList.db.profile.trinket2Slot = BiSList:GetItemIDByName(input) end,
					get = function(info) return BiSList:GetItemNameByID(BiSList.db.profile.trinket2Slot) end,
					order = 50
				},
				addTrinket2Note =
				{
					type = "input",
					name = "Nota",
					desc = "Escribe el item de cabeza",
					set = function(info, input) 	BiSList.db.profile.trinket2Note =input end,
					get = function(info) return BiSList.db.profile.trinket2Note end,
					order = 51
				},
			},
		},
	},
}

profileOptions = {
	name = "Perfiles",
	type = "group",
	childGroups = "tab", --Make sub groups showup as tabs.
	
	args = {
		
	},
}


whisperOptions = {
    name = "Configuración de avisos",
    handler = BiSList,
    type = 'group',
    args = {
        msg = {
            type = 'input',
            name = 'My Message',
            desc = 'The message for my addon',
            
        },
    },
}



local defaults = 
{
	profile = 
	{
		headSlot = 22206,
		shoulderSlot = 22206,
		backSlot = 22206,
		chestSlot = 22206,
		wristSlot = 22206,
		handsSlot = 22206,
		waistSlot = 22206,
		legsSlot = 22206,
		feetSlot = 22206,
		neckSlot = 22206,
		trinket1Slot = 22206,
		trinket2Slot = 22206,
		ring1Slot = 22206,
		ring2Slot = 22206,
		mainHandSlot = 22206,
		offHandSlot = 22206,
		distanceSlot = 22206,

		headNote = "Note",
		shoulderNote = "Note",
		backNote = "Note",
		chestNote = "Note",
		wristNote = "Note",
		handsNote = "Note",
		waistNote = "Note",
		legsNote = "Note",
		feetNote = "Note",
		neckNote = "Note",
		trinket1Note = "Note",
		trinket2Note = "Note",
		ring1Note = "Note",
		ring2Note = "Note",
		mainHandNote = "Note",
		offHandNote = "Note",
		distanceNote = "Note",
	}
}


----------------------------------------------------------
----------------------------------------------------------

function BiSList:OpenTestWindow(input)
	local frame = gui:Create("Frame")
	frame:SetTitle("Test")
	frame:SetStatusText("")
	frame:SetCallback("OnClose", function(widget) gui:Release(widget) end)

	local btn = gui:Create("Button")
	btn:SetText("click")
	btn:SetCallback("OnClick", function() BiSList:ShareProfile() end)
	frame:AddChild(btn)
end


function BiSList:OpenBiSList(input)
	BiSList:PrintList()
end

local submenuOpts

function BiSList:OnInitialize()	

	self.db = LibStub("AceDB-3.0"):New("BiSListDB", defaults, true)

	profileOptions = LibStub("AceDBOptions-3.0"):GetOptionsTable(self.db) --Adds a Profiles UI screen as a submenu to myOptionsTable.

	LibStub("AceConfig-3.0"):RegisterOptionsTable("BiSList", options)
	LibStub("AceConfig-3.0"):RegisterOptionsTable("Susurros", whisperOptions)
	LibStub("AceConfig-3.0"):RegisterOptionsTable("Perfiles", profileOptions)
	
	self.optionsFrame = LibStub("AceConfigDialog-3.0"):AddToBlizOptions("BiSList", "BiSList")
	
	submenuOpts = LibStub("AceConfigDialog-3.0"):AddToBlizOptions("Perfiles", "Perfiles", "BiSList")

	whisperOpts = LibStub("AceConfigDialog-3.0"):AddToBlizOptions("Susurros", "Susurros", "BiSList")

--submenuName is the ID name not shown to user
--"Sounds" is the name of the submenu shown to user
--"Hello world addon" is the text shown at the top of the panel.


end


function BiSList:OnEnable()
	
end

function BiSList:OnDisable()
    -- Called when the addon is disabled
end



function BiSList:GetItemIDByName(name)
	for id = 55000,0,-1 do
        itemName, itemLink, itemRarity, eqItemLevel, itemMinLevel, itemType, itemSubType, itemStackCount,itemEquipLoc, itemTexture, itemSellPrice = GetItemInfo(id)
		if(itemName==name)then
			return id
		end
    end
end

function BiSList:GetItemLinkByID(id)
	if(id == nil) then
		return ""
	end

	itemName, itemLink, itemRarity, eqItemLevel, itemMinLevel, itemType, itemSubType, itemStackCount,itemEquipLoc, itemTexture, itemSellPrice = GetItemInfo(id)
	return itemLink
end

function BiSList:GetItemNameByID(id)
	if(id == nil) then
		return ""
	end

	itemName, itemLink, itemRarity, eqItemLevel, itemMinLevel, itemType, itemSubType, itemStackCount,itemEquipLoc, itemTexture, itemSellPrice = GetItemInfo(id)
	return itemName
end

function BiSList:PrintList()
	local widgetWidth = 600
	local widgetHeight = 500

	local frame = gui:Create("Frame")
	frame:SetTitle("BiS List")
	frame:SetStatusText("")
	frame:SetCallback("OnClose", function(widget) gui:Release(widget) end)
	frame:SetLayout("Fill")
	frame:SetWidth(widgetWidth)
	frame:SetHeight(widgetHeight)

	local scroll = gui:Create("ScrollFrame")
	scroll:SetLayout("Flow")
	
	local headProfileShare = gui:Create("Heading")
	headProfileShare:SetText("Compartir perfil")
	
	local profileOpts = gui:Create("SimpleGroup")
	profileOpts:SetLayout("Flow")
	
	local lblTxt1 = gui:Create("Label")
	lblTxt1:SetText("Compartir este perfil con:")
	
	local txtCharName = gui:Create("EditBox")
	txtCharName:SetWidth(250)
	
	local lblTxt2 = gui:Create("Label")
	lblTxt2:SetText("Como: ")
	
	local txtProfileName = gui:Create("EditBox")
	txtProfileName:SetWidth(250)
	txtProfileName:SetText( UnitName("player") .. " - " .. self.db:GetCurrentProfile())

	local btnShare = gui:Create("Button")
	btnShare:SetText("Compartir")
	btnShare:SetCallback("OnClick", function() BiSList:ShareProfile(txtProfileName:GetText(), txtCharName:GetText()) end)
	
	local headLista = gui:Create("Heading")
	headLista:SetText("BiS List")
	
	local leftCol = gui:Create("SimpleGroup")
	leftCol:SetWidth(260);
	leftCol:SetLayout("Flow")

	local rightCol = gui:Create("SimpleGroup")
	rightCol:SetWidth(260);
	rightCol:SetLayout("Flow")
	

	BiSList:PrintElement(frame,leftCol,"Cabeza","HeadSlot",BiSList.db.profile.headSlot,BiSList.db.profile.headNote,widgetWidth,"left")
	BiSList:PrintElement(frame,rightCol,"Manos","HandsSlot",BiSList.db.profile.handsSlot,BiSList.db.profile.handsNote,widgetWidth,"right")
	BiSList:PrintElement(frame,leftCol,"Collar","NeckSlot",BiSList.db.profile.neckSlot,BiSList.db.profile.neckNote,widgetWidth,"left")
	BiSList:PrintElement(frame,rightCol,"Cintura","WaistSlot",BiSList.db.profile.waistSlot,BiSList.db.profile.waistNote,widgetWidth,"right")
	BiSList:PrintElement(frame,leftCol,"Hombros","ShoulderSlot",BiSList.db.profile.shoulderSlot,BiSList.db.profile.shoulderNote,widgetWidth,"left")
	BiSList:PrintElement(frame,rightCol,"Piernas","LegsSlot",BiSList.db.profile.legsSlot,BiSList.db.profile.legsNote,widgetWidth,"right")
	BiSList:PrintElement(frame,leftCol,"Espalda","BackSlot",BiSList.db.profile.backSlot,BiSList.db.profile.backNote,widgetWidth,"left")
	BiSList:PrintElement(frame,rightCol,"Pies","FeetSlot",BiSList.db.profile.feetSlot,BiSList.db.profile.feetNote,widgetWidth,"right")
	BiSList:PrintElement(frame,leftCol,"Pecho","ChestSlot",BiSList.db.profile.chestSlot,BiSList.db.profile.chestNote,widgetWidth,"left")
	BiSList:PrintElement(frame,rightCol,"Anillo 1","Finger0Slot",BiSList.db.profile.ring1Slot,BiSList.db.profile.ring1Note,widgetWidth,"right")
	BiSList:PrintElement(frame,leftCol,"Brazos","WristSlot",BiSList.db.profile.wristSlot,BiSList.db.profile.wristNote,widgetWidth,"left")
	BiSList:PrintElement(frame,rightCol,"Anillo 2","Finger1Slot",BiSList.db.profile.ring2Slot,BiSList.db.profile.ring2Note,widgetWidth,"right")
	BiSList:PrintElement(frame,leftCol,"Mano derecha","MainHandSlot",BiSList.db.profile.mainHandSlot,BiSList.db.profile.mainHandNote,widgetWidth,"left")
	BiSList:PrintElement(frame,rightCol,"Anillo 3","Trinket0Slot",BiSList.db.profile.trinket1Slot,BiSList.db.profile.trinket1Note,widgetWidth,"right")
	BiSList:PrintElement(frame,leftCol,"Mano izquierda","SecondaryHandSlot",BiSList.db.profile.offHandSlot,BiSList.db.profile.offHandNote,widgetWidth,"left")
	BiSList:PrintElement(frame,rightCol,"Anillo 4","Trinket1Slot",BiSList.db.profile.trinket2Slot,BiSList.db.profile.trinket2Note,widgetWidth,"right")
	BiSList:PrintElement(frame,leftCol,"Disancia","RangedSlot",BiSList.db.profile.distanceSlot,BiSList.db.profile.distanceNote,widgetWidth,"left")
		
	-- AmmoSlot - Ranged ammunition slot
    -- Bag0Slot - Backpack slot
    -- Bag1Slot - First bag slot
    -- Bag2Slot - Second bag slot
    -- Bag3Slot - Third bag slot
    -- ShirtSlot - Shirt slot
    -- TabardSlot - Tabard slot

	frame:AddChild(scroll)
		scroll:AddChild(headLista)
		scroll:AddChild(leftCol)
		scroll:AddChild(rightCol)
		scroll:AddChild(headProfileShare)
		scroll:AddChild(profileOpts)
			profileOpts:AddChild(lblTxt1)
			profileOpts:AddChild(txtCharName)
			profileOpts:AddChild(lblTxt2)
			profileOpts:AddChild(txtProfileName)
			profileOpts:AddChild(btnShare)
end

local bisNumber=0
local levelOffset=0

function BiSList:itemClicked(link)
	BiSList:Print("taraa")
end 


function BiSList:PrintStatus(rFrame)
	rFrame:SetStatusText("BiS counter: " .. bisNumber .. "/17  --  Level offset: " .. levelOffset)
end

function BiSList:ShowToolTip(id)
	GameTooltip:AddLine("A Long String", nil, nil, nil, false)
	GameTooltip:Show()
	BiSList:Print("A Long String")
end

function BiSList:round(n, precision)

  local m = 10^(precision or 0)

  return floor(m*n + 0.5)/m

end

function BiSList:ShowStats(root, bisLink, eqLink)

	local bisStats = GetItemStats(bisLink)
	local eqStats = GetItemStats(eqLink)

	GameTooltip:SetOwner(root.frame, "ANCHOR_RIGHT")
    GameTooltip:ClearLines()
      
	

	--Mostrar las que solo estan en el BiS
	local match = 0
	GameTooltip:AddLine("BiS Item stats", 1,1,1)
	for bk, bv in pairs (bisStats) do 
		match = 0
		for ek, ev in pairs(eqStats) do
			if (bk == ek) then
				match = 1;
			end
		end
		
		if(match == 0)then
			GameTooltip:AddDoubleLine(_G[bk], bv)
		end
	end

	--Mostrar las que estan en el BIS y el equipado
	GameTooltip:AddLine("Shared stats", 1,1,1)
	for bk, bv in pairs (bisStats) do 
		for ek, ev in pairs(eqStats) do
			if (bk == ek) then
				local value = bv-ev
				if(value ~= 0) then
					if(value<0) then
						GameTooltip:AddDoubleLine(_G[bk], value,1,0,0,1,0,0)
					else
						GameTooltip:AddDoubleLine(_G[bk], value)
					end
				end
			end
		end
	end

	--Mostrar las que solo estan en el Equipado
	local match = 0
	GameTooltip:AddLine("Equipped item stats", 1,1,1)
	for ek, ev in pairs(eqStats) do
		match = 0
		for bk, bv in pairs (bisStats) do 
			if (ek == bk) then
				match = 1;
			end
		end
		if(match == 0)then
			GameTooltip:AddDoubleLine(_G[ek], "-" .. ev,1,0,0,1,0,0)
		end
	end

	GameTooltip:Show()
end 


function BiSList:PrintElement(root,baseFrame,title, itemSlot,bisId,notes,w, orient)

	-------------------- RESET ---------------------------
	
	if(title == "Cabeza") then
		bisNumber = 0
		levelOffset = 0
	end
	
	-------------------- VARS ----------------------------
	local invId = select(1, GetInventorySlotInfo(itemSlot))
	local eqId = GetInventoryItemID("player", invId)
	local eqName = select(1,GetItemInfo(eqId))
	local eqLink = select(2,GetItemInfo(eqId))
	local eqLevel = select(4,GetItemInfo(eqId))
	local eqTexture = select(10, GetItemInfo(eqId))

	local bisName = select(1,GetItemInfo(bisId))
	local bisLevel = select(4,GetItemInfo(bisId))
	local bisTexture = select(10,GetItemInfo(bisId))
	local bisLink = select(2,GetItemInfo(bisId))

	-------------------FRAMES ---------------------------
	--HEADING
	--local headHeading = gui:Create("Heading")
	--headHeading:SetText(title)
	--headHeading:SetWidth(w)
	--baseFrame:AddChild(headHeading)

	--NOTES
	local itemNotes = gui:Create("Label")
	itemNotes:SetText(" (" .. notes .. ")")
	itemNotes:SetWidth(150)
	
		

	--EQUIPPED
	if(eqId==nil) then 
		local eqItem = gui:Create("InteractiveLabel")
		eqItem:SetText(eqLink .. " (0)")
		eqItem:SetWidth(300)	
		baseFrame:AddChild(eqItem)
	else
		local eqIcon = gui:Create("Icon")
		eqIcon:SetImage(eqTexture)
		eqIcon:SetImageSize(30,30)
		eqIcon:SetWidth(30)	
		eqIcon:SetCallback("OnEnter",	function(self, button) 
											local alt_key = IsAltKeyDown()
											local shift_key = IsShiftKeyDown()
											local control_key = IsControlKeyDown()

											if(alt_key or shift_key or control_key)then
											else
												SetItemRef(eqLink,eqId) 
											end
										end)
		eqIcon:SetCallback("OnLeave",	function(self, button) 
											local alt_key = IsAltKeyDown()
											local shift_key = IsShiftKeyDown()
											local control_key = IsControlKeyDown()

											if(alt_key or shift_key or control_key)then
											else
												SetItemRef(eqLink,eqId) 
											end
										end)
		eqIcon:SetCallback("OnClick", function(self, button)
											local alt_key = IsAltKeyDown()
											local shift_key = IsShiftKeyDown()
											local control_key = IsControlKeyDown()

											if (button == "LeftButton" or button == "RightButton")  then
												if alt_key then
												elseif shift_key then
													SendChatMessage(eqLink)
												elseif control_key then
												else -- No modifier key is pressed
												end
											else -- Handle MiddleButton
												
											end
										end)
		eqIcon:SetPoint("TOPLEFT", 5, 15)
		baseFrame:AddChild(eqIcon)

	end


	--STATUS
	local statLabel = gui:Create("InteractiveLabel")

	if (eqLink == bisLink) then
		statLabel:SetColor(255,255,0)
		statLabel:SetText("OK!")

		bisNumber = bisNumber +1
	else
		statLabel:SetText(eqLevel - bisLevel)
		statLabel:SetCallback("OnEnter", function() BiSList:ShowStats(statLabel,bisLink,eqLink) end)
		statLabel:SetCallback("OnLeave", function() GameTooltip:Hide() end)
		levelOffset = levelOffset + ((eqLevel - bisLevel))
	end
	statLabel:SetWidth(25)
	baseFrame:AddChild(statLabel)	

	--BIS
	local bisIcon = gui:Create("Icon")
	bisIcon:SetImage(bisTexture)
	bisIcon:SetImageSize(30,30)
	bisIcon:SetWidth(30)
	bisIcon:SetCallback("OnEnter",	function(self, button) 
										local alt_key = IsAltKeyDown()
										local shift_key = IsShiftKeyDown()
										local control_key = IsControlKeyDown()

										if(alt_key or shift_key or control_key)then
										else
											SetItemRef(bisLink,bisId) 
										end
									end)
	bisIcon:SetCallback("OnLeave",	function(self, button) 
										local alt_key = IsAltKeyDown()
										local shift_key = IsShiftKeyDown()
										local control_key = IsControlKeyDown()

										if(alt_key or shift_key or control_key)then
										else
											SetItemRef(bisLink,bisId) 
										end
									end)
	baseFrame:AddChild(bisIcon)

	--local bisItem = gui:Create("InteractiveLabel")
	--bisItem:SetText(bisLink .. "(" .. bisLevel .. ")")
	--bisItem:SetWidth(300)
	--bisItem:SetCallback("OnClick",function() SetItemRef(bisLink,bisId) end)
	--baseFrame:AddChild(bisItem)

	
	if(orient == "right") then
		baseFrame:AddChild(itemNotes)
	else
		baseFrame:AddChild(itemNotes)
	end
	

	BiSList:PrintStatus(root)

	
end

function BiSList:FindItemId(str)
	local index = strfind(str, "item:")

	if(index == nil)then
		return nil
	else
		local temp =strsub(str,index+5)
		local endindex = strfind(temp, ":")
		return strsub(temp,0,endindex -1)
	end
end

function BiSList:ShowItemTooltip(root,itemLink)
	local link = BiSList:GetItemLinkByID(itemId)

	GameTooltip:SetOwner(root.frame, "ANCHOR_RIGHT")
    GameTooltip:ClearLines()
	GameTooltip:SetHyperlink(itemLink)
	GameTooltip:Show()
end

function MsgReceived(self,event,msg)
	local id = BiSList:FindItemId(msg)

	if(id == nil) then
		
	else
		local frame = gui:Create("Window")
		frame:SetTitle("Looted BiS Item")
		frame:SetStatusText("")
		frame:SetCallback("OnClose", function(widget) gui:Release(widget) end)
		frame:SetLayout("Flow")
		frame:SetWidth(300)
		frame:SetHeight(200)
		frame:SetAutoAdjustHeight(true)

		local link = BiSList:GetItemLinkByID(id)
		local texture = select(10,GetItemInfo(id))

		local icon = gui:Create("Icon")
		icon:SetImage(texture)
		icon:SetImageSize(30,30)
		icon:SetWidth(30)	
		icon:SetCallback("OnEnter", function() BiSList:ShowItemTooltip(frame,link)  end)
		icon:SetCallback("OnLeave", function() GameTooltip:Hide() end)
		frame:AddChild(icon)

		local itemLabel = gui:Create("InteractiveLabel")
		itemLabel:SetText(link)
		itemLabel:SetCallback("OnEnter", function() BiSList:ShowItemTooltip(frame,link)  end)
		itemLabel:SetCallback("OnLeave", function() GameTooltip:Hide() end)
		frame:AddChild(itemLabel)
		
	
		BiSList:Print(id)
	end
end

function res() end

ChatFrame_AddMessageEventFilter("CHAT_MSG_RAID",res)

function BiSList:ShareProfile(profileName, profileDest)
	
	local serializedProfile = BiSList:Serialize(self.db.profile, profileName)
	BiSList:SendCommMessage("bislistprofiledata",serializedProfile , "WHISPER", profileDest)
end


function BiSList:OnCommReceived(prefix, message, distribution, sender)
	
	if(prefix=="bislistprofiledata") then

		success, data, profileName = BiSList:Deserialize(message)

		if(success)then
			
			while (BiSList:ProfileExist(profileName)) do
				profileName = "_" .. profileName
			end

			self.db:SetProfile(profileName)
			self.db.profile = data
			BiSList:Print("Recibido el perfil ".. profileName .." de " .. sender)
			
		else
			BiSList:Print("Error: " .. data)
		end

	end
end

function BiSList:ProfileExist(profileName)
	local exist = false
	for k,v in pairs(self.db:GetProfiles()) do
		
		if(v== profileName) then
			exist = true
		end
	end

	return exist
end

BiSList:RegisterComm("bislistprofiledata")






